<?php

include_once('CAS/eoleCAS.php');
include_once('configCAS/cas.inc.php');

// Initialisation du client PHP
if (__CAS_DEBUG){
    EolephpCAS::setDebug('/var/log/phpcas/phpcas-edispatcher.log');
}

EolephpCAS::client(__CAS_VERSION, __CAS_SERVER, __CAS_PORT, "", false);
if (__CAS_VALIDER_CA) {
    EolephpCAS::setCasServerCACert(__CAS_CA_LOCATION);
} else {
    if (method_exists('EolephpCAS', 'setNoCasServerValidation')){
        EolephpCAS::setNoCasServerValidation();
    }
}

if (__CAS_LOGOUT){
    if (method_exists('EolephpCAS', 'eolelogoutRequests')){
        EolephpCAS::eolelogoutRequests(false);
    }
}

// On force l'autehntification
if(EolephpCAS::forceAuthentication()) {
    // Récupérations des attributs
    $attributs=array();
    $attributs=EolephpCAS::getDetails();

    // Stocke les variables CAS dans un tableau $_SESSION["CASATTRIBUTE"]
    $_SESSION["CASATTRIBUTE"]=array();
    foreach ($attributs as $value) {
        $_SESSION["CASATTRIBUTE"] += $value;
    }
    $_SESSION["id"]=uniqid('sso');
    $_SESSION["arenb"]="";
}

function logout() {
    EolephpCAS::logout();
}
