<?php

include_once "uinc.php";
$tableappnotchanged = 0;
$tableurlnotchanged = 0;
\R::exec('CREATE TABLE IF NOT EXISTS icon (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, icon BLOB NULL, md5icon CHAR(32) NULL UNIQUE, updated_at DATETIME NULL)');

$apps=\R::findAll( 'app');

foreach ($apps as $app ) {
    if ($app->old_icon) {
        $icone = $app->old_icon;
    }
    else {
        $tableappnotchanged = 1;
        if (!$app->icon_id) {
            $icone = $app->icon;
        }
    }
    if ($icone) {
        $md5icon = md5($icone);
        $icon = \R::findone('icon', 'md5icon = ?', [$md5icon]);
        if ($icon) {
            $app->icon = $icon;
        }
        else {
            $icon = \R::dispense("icon");
            $icon->icon = $app->icon;
            $icon->md5icon = $md5icon;
            $icon->updated_at = new DateTime();
            $app->icon = $icon;
            \R::store($icon);
        }
        \R::store($app);
    }
}

if ($tableappnotchanged) {
    \R::exec('ALTER TABLE `app` CHANGE `icon` `old_icon` BLOB NULL DEFAULT NULL');
}

$urls=\R::findAll( 'url');

foreach ($urls as $url ) {
    if ($url->old_icon) {
        $icone = $url->old_icon;
    }
    else {
        $tableurlnotchanged = 1;
        if (!$url->icon_id) {
            $icone = $url->icon;
        }
    }

    if ($icone) {
        $md5icon = md5($icone);
        $icon = \R::findone('icon', 'md5icon = ?', [$md5icon]);
        if ($icon) {
            $url->icon = $icon;
        }
        else {
            $icon = \R::dispense("icon");
            $icon->icon = $url->icon;
            $icon->md5icon = $md5icon;
            $icon->updated_at = new DateTime();
            $url->icon = $icon;
            \R::store($icon);
        }
        \R::store($url);
    }
}


if ($tableurlnotchanged) {
    \R::exec('ALTER TABLE `url` CHANGE `icon` `old_icon` BLOB NULL DEFAULT NULL');
}

